#ifndef DUMPDEVICE_H
#define DUMPDEVICE_H

#include <glib.h>
#include <stdbool.h>
#include "dumpheader.h"
#include "arch/arch_dumpdevice.h"

typedef struct _DumpDevice DumpDevice;

struct mem_segment {
	unsigned int	blk;
	unsigned int	len;
};

struct _DumpDevice {

	/* Host data */
	glong			 page_offset;
	struct disk_dump_header	*header;
	struct disk_dump_sub_header	*sub_header;


	char			*bitmap;
	int			bitmap_len;
	char			*dumpable_bitmap;

	int			byte, bit;

	struct mem_segment	*segments;
	int			 num_segments;

	/* Coredump data: */
	int			 file_fd;
	int			 device_fd;
	size_t			 data_offset;
	size_t			 device_page_start;

	const char		*dump_dir;
	char			*device_name;
	char			*file_name;
};

#endif
